Subject: Re: [Patch 4/5] Network Drop Monitor: Adding drop monitor implementation & Netlink protocol

From: Patrick McHardy <[email-masked]>
Date: Thu, 02 Apr 2009 16:42:18 +0200

Herbert Xu wrote:
> On Thu, Apr 02, 2009 at 02:52:23AM -0700, David Miller wrote:
>> It has to do with how the netlink attributes get packed together
>> into the messages.  It's this crap:
>>
>> #define NLMSG_ALIGNTO	4
>> #define NLMSG_ALIGN(len) ( ((len)+NLMSG_ALIGNTO-1) & ~(NLMSG_ALIGNTO-1) )
>>  ...
>> #define NLMSG_NEXT(nlh,len)	 ((len) -= NLMSG_ALIGN((nlh)->nlmsg_len), \
>> 				  (struct nlmsghdr*)(((char*)(nlh)) + NLMSG_ALIGN((nlh)->nlmsg_len)))
>>
>> Thus, nothing in an nlmsg can ever be more than 4 byte aligned.
>> And this is hard coded into the protocol.
> 
> Ah yes, this is the killer.
> 
> I suppose we can modify in-kernel helpers like nla_parse to deal
> with that by copying if it's unaligned.  Though we'll have to
> figure out how to free the memory.

Actually we should be fine since the current netlink helpers only do
bytewise copying anyways. And I think we've pretty much gotten rid of
all the raw attribute accesses.